package com.siit.wfw.frame.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.siit.wfw.frame.dto.LoginVo;
import com.siit.wfw.frame.utils.Convert;
import com.siit.wfw.frame.utils.UserTools;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class FormTools {

   public static String getConfigStr(String configval, Map param) throws Exception {
      StringBuffer result = new StringBuffer();
      if(!"".equals(configval)) {
         String[] strs = configval.split("/");

         for(int i = 0; i < strs.length; ++i) {
            String cmd = strs[i];
            String val = "";
            String cmdlist;
            if(cmd.startsWith("##COL(")) {
               cmdlist = cmd.substring(6, cmd.length() - 1);
               val = param.get(cmdlist).toString();
            } else if(cmd.startsWith("##NUM(")) {
               cmdlist = cmd.substring(6, cmd.length() - 1);
               val = "--num--" + cmdlist;
            } else if(cmd.startsWith("##SUB(")) {
               cmdlist = cmd.substring(6, cmd.length() - 1);
               String[] listm = cmdlist.split(",");
               if(listm.length == 2) {
                  Object d = param.get(listm[0]);
                  if(d != null && !"".equals(d.toString())) {
                     if(d.getClass().getName().equals("java.util.Date")) {
                        val = getFinalValS("##Date(" + listm[1] + ")", (Date)d).toString();
                     } else {
                        String ss = d.toString().replaceAll("-", "");
                        if(ss.length() > listm[1].length()) {
                           val = ss.substring(0, listm[1].length());
                        }
                     }
                  }
               } else if(listm.length == 3) {
                  String var11 = Convert.toReadStr(param.get(listm[0]));
                  if(!"".equals(var11) && var11.length() > Integer.parseInt(listm[2])) {
                     val = var11.substring(Integer.parseInt(listm[1]), Integer.parseInt(listm[2]));
                  }
               }
            } else {
               val = getVal(strs[i]);
            }

            if("".equals(val)) {
               throw new Exception(configval + "--" + cmd);
            }

            result.append(val);
         }
      }

      return result.toString();
   }

   public static void main(String[] args) {
      HashMap param = new HashMap();
      param.put("DATEYEAR", "2018");
      param.put("CREATEDATE", new Date());
      param.put("FORMATDATE", "2019-07-30");

      try {
         System.out.println(getConfigStr("EVS/##COL(DATEYEAR)/##Date(YYYYMMDD)/##NUM(6)", param));
         System.out.println(getConfigStr("EVS/##SUB(CREATEDATE,YYYY)", param));
         System.out.println(getConfigStr("EVS/##SUB(CREATEDATE,YYYYMM)", param));
         System.out.println(getConfigStr("EVS/##SUB(FORMATDATE,0,7)", param));
      } catch (Exception var3) {
         var3.printStackTrace();
      }

   }

   public static String[] getPartition(Object val, String tabuuid, JSONArray viewcols) {
      if(val != null && viewcols != null && viewcols.size() > 0) {
         for(int i = 0; i < viewcols.size(); ++i) {
            JSONObject model = viewcols.getJSONObject(i);
            String columnuuid = model.getString("columnuuid");
            String datatype = model.getString("datatype");
            if(columnuuid.equals(tabuuid)) {
               String formatstr = "";
               if("year".equals(datatype)) {
                  formatstr = "yyyy";
               } else if("month".equals(datatype)) {
                  formatstr = "yyyyMM";
               }

               if(!Convert.isNullOrEmpty(formatstr).booleanValue()) {
                  new SimpleDateFormat(formatstr);
                  String date = Convert.toReadStr(val);
                  return new String[]{date.substring(0, 4), date};
               }
            }
         }
      }

      return null;
   }

   public static Object getInputVal(String inputval, String defaultval, String dataType) {
      Object result = null;
      if("String".equals(dataType)) {
         if(!"".equals(inputval)) {
            result = inputval;
         } else {
            result = getFinalVal(defaultval);
         }
      } else if("Date".equals(dataType)) {
         if(!"".equals(inputval)) {
            result = Convert.parseDate((String)inputval);
         } else {
            result = getFinalVal(defaultval);
         }
      } else if("Integer".equals(dataType)) {
         if(!"".equals(inputval)) {
            result = Integer.valueOf(Integer.parseInt(inputval));
         } else {
            result = Integer.valueOf(Integer.parseInt(defaultval));
         }
      } else if("Long".equals(dataType)) {
         if(!"".equals(inputval)) {
            result = Long.valueOf(Long.parseLong(inputval));
         } else {
            result = Convert.toLong(defaultval);
         }
      } else if("Double".equals(dataType)) {
         if(!"".equals(inputval)) {
            result = Double.valueOf(Double.parseDouble(inputval));
         } else {
            result = Double.valueOf(Double.parseDouble(defaultval));
         }
      }

      return result;
   }

   private static String getVal(String cmd) {
      String result = getFinalVal(cmd).toString();
      return result;
   }

   private static Object getFinalVal(String defaultval) {
      return getFinalValS(defaultval, (Date)null);
   }

   private static Object getFinalValS(String defaultval, Date d) {
      Date currdate = new Date();
      if(d != null) {
         currdate = d;
      }

      if("##UUID".equals(defaultval)) {
         return UUID.randomUUID().toString();
      } else if("##Date".equals(defaultval)) {
         return new Date();
      } else {
         SimpleDateFormat user1;
         if("##Date(YYYY)".equals(defaultval)) {
            user1 = new SimpleDateFormat("yyyy");
            return user1.format(currdate);
         } else if("##Date(YYYY-MM)".equals(defaultval)) {
            user1 = new SimpleDateFormat("yyyy-MM");
            return user1.format(currdate);
         } else if("##Date(YYYY-MM-DD)".equals(defaultval)) {
            user1 = new SimpleDateFormat("yyyy-MM-dd");
            return user1.format(currdate);
         } else if("##Date(YYYYMM)".equals(defaultval)) {
            user1 = new SimpleDateFormat("yyyyMM");
            return user1.format(currdate);
         } else if("##Date(YYYYMMDD)".equals(defaultval)) {
            user1 = new SimpleDateFormat("yyyyMMdd");
            return user1.format(currdate);
         } else {
            LoginVo user;
            if("##USER(ID)".equals(defaultval)) {
               user = UserTools.getUser();
               return user != null?user.getUserkey():"";
            } else if("##USER(BRANCHCODE)".equals(defaultval)) {
               user = UserTools.getUser();
               return user != null?user.getUserBranch().getSfcode():"";
            } else {
               return Convert.toReadStr(defaultval);
            }
         }
      }
   }
}
